import { Set } from "immutable";
import { Type } from "./Type";
import { TypeRef, UnionBuilder, TypeBuilder, TypeLookerUp } from "./TypeBuilder";
import { TypeNames } from "./TypeNames";
export declare class UnifyUnionBuilder extends UnionBuilder<TypeBuilder & TypeLookerUp, TypeRef, TypeRef, TypeRef> {
    private readonly _makeEnums;
    private readonly _unifyTypes;
    constructor(typeBuilder: TypeBuilder & TypeLookerUp, typeNames: TypeNames, _makeEnums: boolean, _unifyTypes: (typesToUnify: TypeRef[], typeNames: TypeNames) => TypeRef);
    protected makeEnum(enumCases: string[], counts: {
        [name: string]: number;
    }): TypeRef;
    protected makeClass(classes: TypeRef[], maps: TypeRef[]): TypeRef;
    protected makeArray(arrays: TypeRef[]): TypeRef;
}
export declare function unifyTypes(types: Set<Type>, typeNames: TypeNames, typeBuilder: TypeBuilder & TypeLookerUp): TypeRef;
